unit Main;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Menus;

type
  TMainForm = class(TForm)
    imgBurpfish: TImage;
    imgDopefish: TImage;
    imgMessage: TImage;
    btnDopefish: TButton;
    procedure btnDopefishClick(Sender: TObject);
  private
    procedure ShowDopefish;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}
{$R burpfish.res}  // Sound of the dopefish

uses
  MMSystem; // For the WAV output

procedure TMainForm.ShowDopefish;
{To learn about the dopefish, visit http://www.dopefish.com
}
var
  Res       : THandle; // Used to play the dopefish sound
  Reshandle : THandle;
begin
  try
    // Step one: show the dopefish
    imgDopefish.Visible := True;
    Application.ProcessMessages;
    Sleep(500); // Wait 1/2 second

    // Try to load the sound resource
    Res := FindResource(HInstance,'DOPEFISH','WAVE');

    // If okay, animate the fish
    if Res <> 0 then
    begin
      // Show the Burpfish
      imgBurpfish.Visible := True;
      imgDopefish.Visible := False;
      Application.ProcessMessages; // Needed for the update, curse this Windoze
      Reshandle := LoadResource(HInstance, Res);

      // Play the sound
      if Reshandle <> 0 then
      begin
        sndPlaySound(LockResource(Reshandle), SND_SYNC or SND_MEMORY);
        Application.ProcessMessages;
        UnlockResource(Reshandle);
        FreeResource(Reshandle);
      end; // of if Reshandle

      // Back to the Dopefish...
      imgDopefish.Visible := True;
      imgBurpfish.Visible := False;
      Application.ProcessMessages;
      Sleep(500);
      imgDopefish.Visible := False;
      Application.ProcessMessages;
    end; // of if Res found

    // Important message
    imgMessage.Visible := True; // Dopefish not dead
    Application.ProcessMessages;
    Sleep(500);
    imgMessage.Visible := False;
  except
    // Just in case...
    imgBurpfish.Visible := False;
    imgDopefish.Visible := False;
    imgMessage.Visible  := False;
  end; // of try..except
end; // of ShowDopefish

procedure TMainForm.btnDopefishClick(Sender: TObject);
begin
  ShowDopefish;
end;

end.
